/*** This Programs/Libraries are (C)opyright by S. Krahmer.
 *** You may use it under the terms of the GPL. You should have
 *** already received the file COPYING that shows you your rights. If not
 *** you can get it at http://www.cs.uni-potsdam.de/homepages/students/linuxer
 *** the logit-package. You will also find some other nice utillities there.
 ***  
 *** THERE IS ABSOLUTELY NO WARRANTY. SO YOU USE IT AT YOUR OWN RISK.
 *** IT WAS WRITTEN IN THE HOPE THAT IT WILL BE USEFULL. I'M NOT RESPONSIBLE
 *** FOR ANY DAMAGE YOU MAYBE GET DUE TO USING MY PROGRAMS.
 ***/

#ifndef LNCF_H
#define LNCF_H

#ifndef __KERNEL__
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include <errno.h>

#include "misc.h"

#define FULL_PATH 100
#define FILE_ONLY 200
#endif	/* __KERNEL__ */

#define HIJACK_SERVICE 241

#define HJS_OPEN   1
#define HJS_CLOSE  2
#define HJS_LOCK   4
#define HJS_UNLOCK 8

#ifndef __KERNEL__
class root {
public:
	root() { }
	virtual ~root() { }
};

int register_object(root*);
int unregister_object(root*);

class process : public root {
private:
   	int pid;
	char cmd[256];
	char status[256];
public:
        virtual ~process() 
        {
           	unregister_object(this);
        }
        
   	process(int p) : pid(p) 
        {
	   	register_object(this);
           	getargs(); 
        }
        int showfd();			// print out own file-descriptors
	int getargs();
	
        int open(int, int);
        int close(int, int);
};

class dir : public root {
private:
   	DIR *dp;
        char *path;
        char *file;
        int how;
public:
        virtual ~dir() 
        { 
           	unregister_object(this);
		
           	closedir(dp); 
                delete [] path; 
                delete [] file;
        }
        
        dir(const char *s, int h = FULL_PATH)
        {
           	register_object(this);
        
           	how = h;
           	path = new char[strlen(s) + 1];
                file = new char[strlen(s) + 256];
                
           	memset(path, 0, strlen(s) + 1);
                memset(file, 0, strlen(s) + 256);
                sprintf(path, "%s", s);
                
           	if ((dp = opendir(s)) == NULL) {
           	       perror("opendir");
                       exit(errno);
                }
                readdir(dp); readdir(dp);	// skip "." and ".."
        }
        char *read();
};

#endif /* __KERNEL__ */
#endif /* LNCF_H */
