/*** This Programs/Libraries are (C)opyright by S. Krahmer.
 *** You may use it under the terms of the GPL. You should have
 *** already received the file COPYING that shows you your rights. If not
 *** you can get it at http://www.cs.uni-potsdam.de/homepages/students/linuxer
 *** the logit-package. You will also find some other nice utillities there.
 ***  
 *** THERE IS ABSOLUTELY NO WARRANTY. SO YOU USE IT AT YOUR OWN RISK.
 *** IT WAS WRITTEN IN THE HOPE THAT IT WILL BE USEFULL. I'M NOT RESPONSIBLE
 *** FOR ANY DAMAGE YOU MAYBE GET DUE TO USING MY PROGRAMS.
 ***/

#include <stdlib.h>
#include <vector>
#include <iostream>

#include "lncf.h"
#include "misc.h"
#include "config.h"

inline int max(int a, int b)
{
	return (a < b) ? b : a;
}

// show all processes file-descriptors
int do_all()
{
   	dir d("/proc", FILE_ONLY);
        char *path;
        
        while ((path = d.read())) {
           	if (atoi(path)) {
                   	do_pid(atoi(path));
                }
        }
        return 0;
}

// only show descriptors of process pid
int do_pid(int pid)
{
        process p(pid);
        p.showfd();
        return 0;
}

static vector<root *> regtable;

int register_object(root *thisp)
{
        regtable.push_back(thisp);       
        return regtable.size();
}

int unregister_object(root *thisp)
{	
        for (int i = 0; i < (int)regtable.size(); i++) {
           	if (regtable[i] == thisp) {
                   	regtable[i] = NULL;
                }
        }
        return 0;
}

RETSIGTYPE sighandler(int x)
{
		
	cout<<"Caught signal "<<x<<", unregistering services ...\n";
	
	for (int i = 0; i < (int)regtable.size(); i++) {
		
		// if not NULL and not on stack (means: not a pointer)
		if (regtable[i] && (int)regtable[i] < 0xb000000) {
			cout<<"unregister "<<regtable[i]<<" .\n";
			delete regtable[i];
		}
	}
	exit(0);
}

int check_syscall()
{

   	cout<<"Checking for installed service-module ...\n";
        
   	// if installed, go outta here
   	if (hijack_service(0, 0, 0, 0) == 0) {
           	cout<<"Found request-handler installed. Continue working.\n";
           	return 0;
        }
        cout<<"Module not installed. Loading ...\n";
        
        // OUCH! Why have they stolen the smart kerneld where user could
        // open messagequeue to it ???
        system("insmod /lib/modules/hjserv.o");
        cout<<"Done. Try service again ...\n";
        if (hijack_service(0, 0, 0, 0) == 0) {
           	cout<<"OK. The things work now! Let's rock.\n";
                return 0;
        }
        // hmm... module not there?
        
        cout<<"Huh? Can't load hjserv-module. Please do it by hand and start me again.\n";
        return 0;
}
